package cn.com.infosec.ocsp;

import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.ocsp.OCSPObjectIdentifiers;
import cn.com.infosec.asn1.ocsp.OCSPResponse;
import cn.com.infosec.asn1.ocsp.OCSPResponseStatus;
import cn.com.infosec.asn1.ocsp.ResponseBytes;
import java.io.IOException;

public class OCSPRespGenerator {
   public static final int SUCCESSFUL = 0;
   public static final int MALFORMED_REQUEST = 1;
   public static final int INTERNAL_ERROR = 2;
   public static final int TRY_LATER = 3;
   public static final int SIG_REQUIRED = 5;
   public static final int UNAUTHORIZED = 6;

   public OCSPResp generate(int status, Object response) {
      if (response == null) {
         OCSPResponse var8;
         OCSPResponse var10002 = var8 = new OCSPResponse;
         OCSPResponseStatus response2;
         response2 = new OCSPResponseStatus.<init>(status);
         var10002.<init>(response2, (ResponseBytes)null);
         return new OCSPResp(var8);
      } else if (response instanceof BasicOCSPResp) {
         BasicOCSPResp var5 = (BasicOCSPResp)response;

         DEROctetString response1;
         label27: {
            IOException var10000;
            label35: {
               DEROctetString var11;
               boolean var10001;
               try {
                  var11 = new DEROctetString;
               } catch (IOException var4) {
                  var10000 = var4;
                  var10001 = false;
                  break label35;
               }

               response1 = var11;

               try {
                  var11.<init>(var5.getEncoded());
                  break label27;
               } catch (IOException var3) {
                  var10000 = var3;
                  var10001 = false;
               }
            }

            IOException var6 = var10000;
            throw new OCSPException("can't encode object.", var6);
         }

         ResponseBytes var7;
         var7 = new ResponseBytes.<init>(OCSPObjectIdentifiers.id_pkix_ocsp_basic, response1);
         return new OCSPResp(new OCSPResponse(new OCSPResponseStatus(status), var7));
      } else {
         throw new OCSPException("unknown response object");
      }
   }
}
